// Generated by gencpp from file object_recognition_msgs/ObjectType.msg
// DO NOT EDIT!


#ifndef OBJECT_RECOGNITION_MSGS_MESSAGE_OBJECTTYPE_H
#define OBJECT_RECOGNITION_MSGS_MESSAGE_OBJECTTYPE_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace object_recognition_msgs
{
template <class ContainerAllocator>
struct ObjectType_
{
  typedef ObjectType_<ContainerAllocator> Type;

  ObjectType_()
    : key()
    , db()  {
    }
  ObjectType_(const ContainerAllocator& _alloc)
    : key(_alloc)
    , db(_alloc)  {
  (void)_alloc;
    }



   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _key_type;
  _key_type key;

   typedef std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> _db_type;
  _db_type db;





  typedef boost::shared_ptr< ::object_recognition_msgs::ObjectType_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_recognition_msgs::ObjectType_<ContainerAllocator> const> ConstPtr;

}; // struct ObjectType_

typedef ::object_recognition_msgs::ObjectType_<std::allocator<void> > ObjectType;

typedef boost::shared_ptr< ::object_recognition_msgs::ObjectType > ObjectTypePtr;
typedef boost::shared_ptr< ::object_recognition_msgs::ObjectType const> ObjectTypeConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::object_recognition_msgs::ObjectType_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::object_recognition_msgs::ObjectType_<ContainerAllocator1> & lhs, const ::object_recognition_msgs::ObjectType_<ContainerAllocator2> & rhs)
{
  return lhs.key == rhs.key &&
    lhs.db == rhs.db;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::object_recognition_msgs::ObjectType_<ContainerAllocator1> & lhs, const ::object_recognition_msgs::ObjectType_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace object_recognition_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::object_recognition_msgs::ObjectType_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::object_recognition_msgs::ObjectType_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::object_recognition_msgs::ObjectType_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ac757ec5be1998b0167e7efcda79e3cf";
  }

  static const char* value(const ::object_recognition_msgs::ObjectType_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xac757ec5be1998b0ULL;
  static const uint64_t static_value2 = 0x167e7efcda79e3cfULL;
};

template<class ContainerAllocator>
struct DataType< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
{
  static const char* value()
  {
    return "object_recognition_msgs/ObjectType";
  }

  static const char* value(const ::object_recognition_msgs::ObjectType_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
{
  static const char* value()
  {
    return "################################################## OBJECT ID #########################################################\n"
"\n"
"# Contains information about the type of a found object. Those two sets of parameters together uniquely define an\n"
"# object\n"
"\n"
"# The key of the found object: the unique identifier in the given db\n"
"string key\n"
"\n"
"# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding\n"
"# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"\n"
"# There is no conventional format for those parameters and it's nice to keep that flexibility.\n"
"# The object_recognition_core as a generic DB type that can read those fields\n"
"# Current examples:\n"
"# For CouchDB:\n"
"#   type: 'CouchDB'\n"
"#   root: 'http://localhost:5984'\n"
"#   collection: 'object_recognition'\n"
"# For SQL household database:\n"
"#   type: 'SqlHousehold'\n"
"#   host: 'wgs36'\n"
"#   port: 5432\n"
"#   user: 'willow'\n"
"#   password: 'willow'\n"
"#   name: 'household_objects'\n"
"#   module: 'tabletop'\n"
"string db\n"
;
  }

  static const char* value(const ::object_recognition_msgs::ObjectType_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.key);
      stream.next(m.db);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ObjectType_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::object_recognition_msgs::ObjectType_<ContainerAllocator>& v)
  {
    s << indent << "key: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.key);
    s << indent << "db: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>::stream(s, indent + "  ", v.db);
  }
};

} // namespace message_operations
} // namespace ros

#endif // OBJECT_RECOGNITION_MSGS_MESSAGE_OBJECTTYPE_H
