// Generated by gencpp from file object_recognition_msgs/RecognizedObject.msg
// DO NOT EDIT!


#ifndef OBJECT_RECOGNITION_MSGS_MESSAGE_RECOGNIZEDOBJECT_H
#define OBJECT_RECOGNITION_MSGS_MESSAGE_RECOGNIZEDOBJECT_H


#include <string>
#include <vector>
#include <memory>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <object_recognition_msgs/ObjectType.h>
#include <sensor_msgs/PointCloud2.h>
#include <shape_msgs/Mesh.h>
#include <geometry_msgs/Point.h>
#include <geometry_msgs/PoseWithCovarianceStamped.h>

namespace object_recognition_msgs
{
template <class ContainerAllocator>
struct RecognizedObject_
{
  typedef RecognizedObject_<ContainerAllocator> Type;

  RecognizedObject_()
    : header()
    , type()
    , confidence(0.0)
    , point_clouds()
    , bounding_mesh()
    , bounding_contours()
    , pose()  {
    }
  RecognizedObject_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , type(_alloc)
    , confidence(0.0)
    , point_clouds(_alloc)
    , bounding_mesh(_alloc)
    , bounding_contours(_alloc)
    , pose(_alloc)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef  ::object_recognition_msgs::ObjectType_<ContainerAllocator>  _type_type;
  _type_type type;

   typedef float _confidence_type;
  _confidence_type confidence;

   typedef std::vector< ::sensor_msgs::PointCloud2_<ContainerAllocator> , typename std::allocator_traits<ContainerAllocator>::template rebind_alloc< ::sensor_msgs::PointCloud2_<ContainerAllocator> >> _point_clouds_type;
  _point_clouds_type point_clouds;

   typedef  ::shape_msgs::Mesh_<ContainerAllocator>  _bounding_mesh_type;
  _bounding_mesh_type bounding_mesh;

   typedef std::vector< ::geometry_msgs::Point_<ContainerAllocator> , typename std::allocator_traits<ContainerAllocator>::template rebind_alloc< ::geometry_msgs::Point_<ContainerAllocator> >> _bounding_contours_type;
  _bounding_contours_type bounding_contours;

   typedef  ::geometry_msgs::PoseWithCovarianceStamped_<ContainerAllocator>  _pose_type;
  _pose_type pose;





  typedef boost::shared_ptr< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> const> ConstPtr;

}; // struct RecognizedObject_

typedef ::object_recognition_msgs::RecognizedObject_<std::allocator<void> > RecognizedObject;

typedef boost::shared_ptr< ::object_recognition_msgs::RecognizedObject > RecognizedObjectPtr;
typedef boost::shared_ptr< ::object_recognition_msgs::RecognizedObject const> RecognizedObjectConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >::stream(s, "", v);
return s;
}


template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator==(const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator1> & lhs, const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator2> & rhs)
{
  return lhs.header == rhs.header &&
    lhs.type == rhs.type &&
    lhs.confidence == rhs.confidence &&
    lhs.point_clouds == rhs.point_clouds &&
    lhs.bounding_mesh == rhs.bounding_mesh &&
    lhs.bounding_contours == rhs.bounding_contours &&
    lhs.pose == rhs.pose;
}

template<typename ContainerAllocator1, typename ContainerAllocator2>
bool operator!=(const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator1> & lhs, const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator2> & rhs)
{
  return !(lhs == rhs);
}


} // namespace object_recognition_msgs

namespace ros
{
namespace message_traits
{





template <class ContainerAllocator>
struct IsMessage< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f92c4cb29ba11f26c5f7219de97e900d";
  }

  static const char* value(const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf92c4cb29ba11f26ULL;
  static const uint64_t static_value2 = 0xc5f7219de97e900dULL;
};

template<class ContainerAllocator>
struct DataType< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
{
  static const char* value()
  {
    return "object_recognition_msgs/RecognizedObject";
  }

  static const char* value(const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
{
  static const char* value()
  {
    return "##################################################### HEADER ###########################################################\n"
"\n"
"# The header frame corresponds to the pose frame, NOT the point_cloud frame.\n"
"Header header\n"
"\n"
"################################################## OBJECT INFO #########################################################\n"
"\n"
"# Contains information about the type and the position of a found object\n"
"# Some of those fields might not be filled because the used techniques do not fill them or because the user does not\n"
"# request them\n"
"\n"
"# The type of the found object\n"
"object_recognition_msgs/ObjectType type\n"
"\n"
"#confidence: how sure you are it is that object and not another one.\n"
"# It is between 0 and 1 and the closer to one it is the better\n"
"float32 confidence\n"
"\n"
"################################################ OBJECT CLUSTERS #######################################################\n"
"\n"
"# Sometimes you can extract the 3d points that belong to the object, in the frames of the original sensors\n"
"# (it is an array as you might have several sensors)\n"
"sensor_msgs/PointCloud2[] point_clouds\n"
"\n"
"# Sometimes, you can only provide a bounding box/shape, even in 3d\n"
"# This is in the pose frame\n"
"shape_msgs/Mesh bounding_mesh\n"
"\n"
"# Sometimes, you only have 2d input so you can't really give a pose, you just get a contour, or a box\n"
"# The last point will be linked to the first one automatically\n"
"geometry_msgs/Point[] bounding_contours\n"
"\n"
"#################################################### POSE INFO #########################################################\n"
"\n"
"# This is the result that everybody expects : the pose in some frame given with the input. The units are radian/meters\n"
"# as usual\n"
"geometry_msgs/PoseWithCovarianceStamped pose\n"
"\n"
"================================================================================\n"
"MSG: std_msgs/Header\n"
"# Standard metadata for higher-level stamped data types.\n"
"# This is generally used to communicate timestamped data \n"
"# in a particular coordinate frame.\n"
"# \n"
"# sequence ID: consecutively increasing ID \n"
"uint32 seq\n"
"#Two-integer timestamp that is expressed as:\n"
"# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n"
"# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n"
"# time-handling sugar is provided by the client library\n"
"time stamp\n"
"#Frame this data is associated with\n"
"string frame_id\n"
"\n"
"================================================================================\n"
"MSG: object_recognition_msgs/ObjectType\n"
"################################################## OBJECT ID #########################################################\n"
"\n"
"# Contains information about the type of a found object. Those two sets of parameters together uniquely define an\n"
"# object\n"
"\n"
"# The key of the found object: the unique identifier in the given db\n"
"string key\n"
"\n"
"# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding\n"
"# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"\n"
"# There is no conventional format for those parameters and it's nice to keep that flexibility.\n"
"# The object_recognition_core as a generic DB type that can read those fields\n"
"# Current examples:\n"
"# For CouchDB:\n"
"#   type: 'CouchDB'\n"
"#   root: 'http://localhost:5984'\n"
"#   collection: 'object_recognition'\n"
"# For SQL household database:\n"
"#   type: 'SqlHousehold'\n"
"#   host: 'wgs36'\n"
"#   port: 5432\n"
"#   user: 'willow'\n"
"#   password: 'willow'\n"
"#   name: 'household_objects'\n"
"#   module: 'tabletop'\n"
"string db\n"
"\n"
"================================================================================\n"
"MSG: sensor_msgs/PointCloud2\n"
"# This message holds a collection of N-dimensional points, which may\n"
"# contain additional information such as normals, intensity, etc. The\n"
"# point data is stored as a binary blob, its layout described by the\n"
"# contents of the \"fields\" array.\n"
"\n"
"# The point cloud data may be organized 2d (image-like) or 1d\n"
"# (unordered). Point clouds organized as 2d images may be produced by\n"
"# camera depth sensors such as stereo or time-of-flight.\n"
"\n"
"# Time of sensor data acquisition, and the coordinate frame ID (for 3d\n"
"# points).\n"
"Header header\n"
"\n"
"# 2D structure of the point cloud. If the cloud is unordered, height is\n"
"# 1 and width is the length of the point cloud.\n"
"uint32 height\n"
"uint32 width\n"
"\n"
"# Describes the channels and their layout in the binary data blob.\n"
"PointField[] fields\n"
"\n"
"bool    is_bigendian # Is this data bigendian?\n"
"uint32  point_step   # Length of a point in bytes\n"
"uint32  row_step     # Length of a row in bytes\n"
"uint8[] data         # Actual point data, size is (row_step*height)\n"
"\n"
"bool is_dense        # True if there are no invalid points\n"
"\n"
"================================================================================\n"
"MSG: sensor_msgs/PointField\n"
"# This message holds the description of one point entry in the\n"
"# PointCloud2 message format.\n"
"uint8 INT8    = 1\n"
"uint8 UINT8   = 2\n"
"uint8 INT16   = 3\n"
"uint8 UINT16  = 4\n"
"uint8 INT32   = 5\n"
"uint8 UINT32  = 6\n"
"uint8 FLOAT32 = 7\n"
"uint8 FLOAT64 = 8\n"
"\n"
"string name      # Name of field\n"
"uint32 offset    # Offset from start of point struct\n"
"uint8  datatype  # Datatype enumeration, see above\n"
"uint32 count     # How many elements in the field\n"
"\n"
"================================================================================\n"
"MSG: shape_msgs/Mesh\n"
"# Definition of a mesh\n"
"\n"
"# list of triangles; the index values refer to positions in vertices[]\n"
"MeshTriangle[] triangles\n"
"\n"
"# the actual vertices that make up the mesh\n"
"geometry_msgs/Point[] vertices\n"
"\n"
"================================================================================\n"
"MSG: shape_msgs/MeshTriangle\n"
"# Definition of a triangle's vertices\n"
"uint32[3] vertex_indices\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Point\n"
"# This contains the position of a point in free space\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/PoseWithCovarianceStamped\n"
"# This expresses an estimated pose with a reference coordinate frame and timestamp\n"
"\n"
"Header header\n"
"PoseWithCovariance pose\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/PoseWithCovariance\n"
"# This represents a pose in free space with uncertainty.\n"
"\n"
"Pose pose\n"
"\n"
"# Row-major representation of the 6x6 covariance matrix\n"
"# The orientation parameters use a fixed-axis representation.\n"
"# In order, the parameters are:\n"
"# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)\n"
"float64[36] covariance\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Pose\n"
"# A representation of pose in free space, composed of position and orientation. \n"
"Point position\n"
"Quaternion orientation\n"
"\n"
"================================================================================\n"
"MSG: geometry_msgs/Quaternion\n"
"# This represents an orientation in free space in quaternion form.\n"
"\n"
"float64 x\n"
"float64 y\n"
"float64 z\n"
"float64 w\n"
;
  }

  static const char* value(const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.type);
      stream.next(m.confidence);
      stream.next(m.point_clouds);
      stream.next(m.bounding_mesh);
      stream.next(m.bounding_contours);
      stream.next(m.pose);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct RecognizedObject_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::object_recognition_msgs::RecognizedObject_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::object_recognition_msgs::RecognizedObject_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "type: ";
    s << std::endl;
    Printer< ::object_recognition_msgs::ObjectType_<ContainerAllocator> >::stream(s, indent + "  ", v.type);
    s << indent << "confidence: ";
    Printer<float>::stream(s, indent + "  ", v.confidence);
    s << indent << "point_clouds[]" << std::endl;
    for (size_t i = 0; i < v.point_clouds.size(); ++i)
    {
      s << indent << "  point_clouds[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::sensor_msgs::PointCloud2_<ContainerAllocator> >::stream(s, indent + "    ", v.point_clouds[i]);
    }
    s << indent << "bounding_mesh: ";
    s << std::endl;
    Printer< ::shape_msgs::Mesh_<ContainerAllocator> >::stream(s, indent + "  ", v.bounding_mesh);
    s << indent << "bounding_contours[]" << std::endl;
    for (size_t i = 0; i < v.bounding_contours.size(); ++i)
    {
      s << indent << "  bounding_contours[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::geometry_msgs::Point_<ContainerAllocator> >::stream(s, indent + "    ", v.bounding_contours[i]);
    }
    s << indent << "pose: ";
    s << std::endl;
    Printer< ::geometry_msgs::PoseWithCovarianceStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.pose);
  }
};

} // namespace message_operations
} // namespace ros

#endif // OBJECT_RECOGNITION_MSGS_MESSAGE_RECOGNIZEDOBJECT_H
