// Auto-generated. Do not edit!

// (in-package object_recognition_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Table = require('./Table.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class TableArray {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.tables = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('tables')) {
        this.tables = initObj.tables
      }
      else {
        this.tables = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type TableArray
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [tables]
    // Serialize the length for message field [tables]
    bufferOffset = _serializer.uint32(obj.tables.length, buffer, bufferOffset);
    obj.tables.forEach((val) => {
      bufferOffset = Table.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type TableArray
    let len;
    let data = new TableArray(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [tables]
    // Deserialize array length for message field [tables]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.tables = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.tables[i] = Table.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    object.tables.forEach((val) => {
      length += Table.getMessageSize(val);
    });
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'object_recognition_msgs/TableArray';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'd1c853e5acd0ed273eb6682dc01ab428';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    # Just an array of tables
    object_recognition_msgs/Table[] tables
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: object_recognition_msgs/Table
    # Informs that a planar table has been detected at a given location
    
    Header header
    
    # The pose gives you the transform that take you to the coordinate system
    # of the table, with the origin somewhere in the table plane and the 
    # z axis normal to the plane
    geometry_msgs/Pose pose
    
    # There is no guarantee that the table does NOT extend further than the
    # convex hull; this is just as far as we've observed it.
    # The origin of the table coordinate system is inside the convex hull
    
    # Set of points forming the convex hull of the table
    geometry_msgs/Point[] convex_hull
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new TableArray(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.tables !== undefined) {
      resolved.tables = new Array(msg.tables.length);
      for (let i = 0; i < resolved.tables.length; ++i) {
        resolved.tables[i] = Table.Resolve(msg.tables[i]);
      }
    }
    else {
      resolved.tables = []
    }

    return resolved;
    }
};

module.exports = TableArray;
